/*  -*- c++ -*-
 * ** PIR Private Directory Service prototype
 * ** Copyright (C) 2002 Alexander Iliev <iliev@nimbus.dartmouth.edu>
 * **
 * ** This program is free software; you can redistribute it and/or modify
 * ** it under the terms of the GNU General Public License as published by
 * ** the Free Software Foundation; either version 2 of the License, or
 * ** (at your option) any later version.
 * **
 * ** This program is distributed in the hope that it will be useful,
 * ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 * ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * ** GNU General Public License for more details.
 * **
 * ** You should have received a copy of the GNU General Public License
 * ** along with this program; if not, write to the Free Software
 * ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * */

/*
 * card/hostcall.h
 * alex iliev, nov 2002
 */

#include <common/hostcall.h>
#include <common/exceptions.h>

#include <common/utils.h>


//
// the user functions for various services
//
host_status_t host_fetch_blob (const object_id& id,
			       blob & o_result);

host_status_t host_fetch_clearrecord (const object_id&,
				      Record & o_result);

host_status_t host_write_blob (const named_blob&);


//
// the new blob IO functions
// make them throw exceptions instead of return this funky status value
//
void host_read_blob (const std::string& basedir,
		     const object_name_t& id,
		     ByteBuffer & o_result)
    throw (host_exception, xdr_exception, comm_exception);

void host_write_blob (const std::string& basedir,
		      const object_name_t& id,
		      const ByteBuffer & blob)
    throw (host_exception, xdr_exception, comm_exception);





// send some notification to the host
host_status_t host_notice (host_notice_t);




//
// the function which will be used to invoke services on the host
//
host_status_t invoke_host (host_service_id_t service,
			   const ByteBuffer& params,
			   ByteBuffer& o_result)
    throw (xdr_exception, host_exception, comm_exception);


// actually it would be rather nice to have an object here
class HostCaller {

};



// communicator over TCP

	
